package org.gcube.gcat.persistence.ckan;

import java.util.Arrays;
import java.util.List;

import org.gcube.gcat.ContextTest;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.fasterxml.jackson.databind.ObjectMapper;

public class CKANGroupTest extends ContextTest {
	
	private static Logger logger = LoggerFactory.getLogger(CKANGroupTest.class);
	
	@Test
	public void list() throws Exception {
		CKANGroup ckanGroup = new CKANGroup();
		String ret = ckanGroup.list(10, 0);
		logger.debug("{}", ret);
	}
	
	@Test
	public void read() throws Exception {
		CKANGroup ckanGroup = new CKANGroup();
		ckanGroup.setApiKey(CKANUtility.getSysAdminAPI());
		String name = "abundance-level";
		ckanGroup.setName(name);
		String ret = ckanGroup.read();
		logger.debug("{}", ret);
	}
	
	public static List<String> listGroup() throws Exception {
		CKANGroup group = new CKANGroup();
		String groups = group.list(1000, 0);
		ObjectMapper objectMapper = new ObjectMapper();
		String[] groupArray = objectMapper.readValue(groups, String[].class);
		return Arrays.asList(groupArray);
	}
	
	@Test
	public void createDeleteGroup() throws Exception {
		CKANGroup ckanGroup = new CKANGroup();
		ckanGroup.setApiKey(CKANUtility.getSysAdminAPI());
		String name = "my-test-group";
		ckanGroup.setName(name);
		ckanGroup.create();
		ckanGroup.delete(true);
	}
	
	// @Test
	public void listAllGroups() throws Exception {
		ContextTest.setContextByName("/d4science.research-infrastructures.eu/D4Research/AGINFRAplusDev");
		CKANGroup ckanGroup = new CKANGroup();
		ckanGroup.setApiKey(CKANUtility.getSysAdminAPI());
		List<String> groups = listGroup();
		logger.debug("Groups are:\n{}", groups);
	}
	
	// @Test
	public void deleteAllGroups() throws Exception {
		//ContextTest.setContextByName("/d4science.research-infrastructures.eu/D4Research/AGINFRAplusDev");
		CKANGroup ckanGroup = new CKANGroup();
		ckanGroup.setApiKey(CKANUtility.getSysAdminAPI());
		List<String> groups = listGroup();
		for(String name : groups) {
			ckanGroup.setName(name);
			ckanGroup.delete(true);
		}
	}
}
